## opam 1.1.0

=== debian/changelog ===
opam (1.1.0-1) unstable; urgency=low

  * New upstream release.
    + Update patch (fix spelling errors).
  * Link against "re.str", added in debian/buildsys/myocamlbuild.ml.
  * Only install "opam" and "opam-admin" binaries, as upstream does.
  * Add build-essential to Depends and ocaml to Recommends.

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 24 Nov 2013 15:46:57 +0100

opam (1.0.0-1) unstable; urgency=low

  * Initial upload (Closes: #641986)

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 16 Jun 2013 15:03:14 +0200

## opam 1.1.1

=== Makefile ===
-include Makefile.config

LOCAL_OCPBUILD=./ocp-build/ocp-build -no-use-ocamlfind
OCPBUILD ?= $(LOCAL_OCPBUILD)
SRC_EXT=src_ext
TARGETS = opam opam-admin opam-installer

.PHONY: all

all: $(LOCAL_OCPBUILD) META
	$(MAKE) clone
	$(MAKE) compile

cold:
	./shell/bootstrap-ocaml.sh
	env PATH=$$PATH:`pwd`/bootstrap/ocaml/bin ./configure
	env PATH=$$PATH:`pwd`/bootstrap/ocaml/bin $(MAKE)

scan: $(LOCAL_OCPBUILD)
	$(OCPBUILD) -scan
sanitize: $(LOCAL_OCPBUILD)
	$(OCPBUILD)
byte: $(LOCAL_OCPBUILD)
	$(OCPBUILD) -byte
opt: $(LOCAL_OCPBUILD)
	$(OCPBUILD) -asm

OCAMLBUILD_FLAGS=\
	-Is src/core,src/client,src/repositories,src/solver,src/scripts \
	-use-ocamlfind -pkgs re.glob,re.pcre,re.str,re.perl,ocamlgraph,cmdliner,cudf,dose3 \
	-classic-display
with-ocamlbuild: autogen
	@for i in core repositories solver client; do\
	  echo Compiling opam-$$i;\
	  find src/$$i -type f \( -not -name opamMain.ml \) \
	                       \( -name \*.ml -or -name \*.mly -or -name \*.mll \)\
	    | xargs -n 1 basename\
	    | awk -F. "{ print (toupper(substr(\$$1,0,1)) substr(\$$1,2)) }"\
	    > src/$$i/opam-$$i.mllib &&\
	  ocamlbuild $(OCAMLBUILD_FLAGS) opam-$$i.cma opam-$$i.cmxa;\
	done;\
	ocamlbuild $(OCAMLBUILD_FLAGS) opamMain.native opam_admin.native &&\
	ln -sf _build/src/client/opamMain.native opam &&\
	ln -sf _build/src/scripts/opam_admin.native opam-admin

$(LOCAL_OCPBUILD): ocp-build/ocp-build.boot ocp-build/win32_c.c
	$(MAKE) -C ocp-build

OCAMLFIND_DIR=$(shell ocamlfind printconf destdir)
prepare: depends.ocp.in
	sed "s|%{lib}%|$(OCAMLFIND_DIR)|g" depends.ocp.in > depends.ocp

autogen: src/core/opamGitVersion.ml src/core/opamScript.ml src/core/opamVersion.ml

compile: $(LOCAL_OCPBUILD) autogen
	$(OCPBUILD) -init -scan $(TARGET)

clone: src/core/opamVersion.ml
	$(MAKE) -C $(SRC_EXT)

clean:
	rm -rf _obuild
	rm -f *.annot src/*.annot
	rm -f ocp-build.*
	rm -rf _build
	rm -rf config.log config.status META Makefile.config
	$(MAKE) -C $(SRC_EXT) clean
	$(MAKE) -C ocp-build clean
	rm -f $(OPAM_FULL_TARGZ)

distclean: clean
	$(MAKE) -C $(SRC_EXT) distclean
	rm -f META Makefile.config config.log config.status
	rm -f src/core/opamVersion.ml src/core/opamGitVersion.ml src/core/opamScript.ml

.PHONY: tests

tests:
	$(MAKE) -C tests all

tests-local:
	$(MAKE) -C tests local

tests-git:
	$(MAKE) -C tests git

%-install:
	@if [ -e _obuild/$*/$*.asm ]; then \
	  echo "install _obuild/$*/$*.asm" && \
	  cp _obuild/$*/$*.asm $(DESTDIR)$(prefix)/bin/$*; \
	else \
	  echo "install _obuild/$*/$*.byte" && \
	  cp _obuild/$*/$*.byte $(DESTDIR)$(prefix)/bin/$*; \
	fi

%-install-with-ocamlbuild:
	@if [ -e $* ]; then\
	  echo "install $*" && cp $* $(DESTDIR)$(prefix)/bin/$*;\
	fi

META: META.in
	sed 's/@VERSION@/$(version)/g' < $< > $@

src/core/opamVersion.ml:
	@echo
	@echo "    ERROR: you need to run ./configure."
	@echo
	@exit 1

.PHONY: src/core/opamGitVersion.ml
src/core/opamGitVersion.ml:
	ocaml shell/get-git-id.ml $@

src/core/opamScript.ml: shell/ src/core/opamVersion.ml
	ocaml shell/crunch.ml "complete"     < shell/opam_completion.sh > $@
	ocaml shell/crunch.ml "complete_zsh" < shell/opam_completion_zsh.sh >> $@
	ocaml shell/crunch.ml "switch_eval"  < shell/opam_switch_eval.sh >> $@

.PHONY: uninstall install install-with-ocamlbuild
install:
	mkdir -p $(DESTDIR)$(prefix)/bin
	$(MAKE) $(TARGETS:%=%-install)
	mkdir -p $(DESTDIR)$(mandir)/man1 && cp doc/man/* $(DESTDIR)$(mandir)/man1
install-with-ocamlbuild:
	mkdir -p $(DESTDIR)$(prefix)/bin
	$(MAKE) $(TARGETS:%=%-install-with-ocamlbuild)
	mkdir -p $(DESTDIR)$(mandir)/man1 && cp doc/man/* $(DESTDIR)$(mandir)/man1
uninstall:
	rm -f $(prefix)/bin/opam*
	rm -f $(mandir)/man1/opam*

CORE_LIB   = opam-core
REPO_LIB   = opam-repositories
SOLVER_LIB = opam-solver
CLIENT_LIB = opam-client

CORE_NOMLI = opamGlobals.ml opamParser.ml opamLexer.ml opamLineLexer.ml
CORE_MLI   = $(foreach i, $(shell find src/core -name "*.mli"), $(notdir $i))
REPO_MLI   = $(foreach i, $(shell find src/repositories -name "*.mli"), $(notdir $i))
SOLVER_MLI = $(foreach i, $(shell find src/solver -name "*.mli"), $(notdir $i))
CLIENT_MLI = $(foreach i, $(shell find src/client -name "*.mli"), $(notdir $i))

CORE_FILES   = $(CORE_LIB:%=%.a) $(CORE_LIB:%=%.cma) $(CORE_LIB:%=%.cmxa)\
	       $(CORE_MLI:%.mli=%.cmi) $(CORE_NOMLI:%.ml=%.cmi)
REPO_FILES   = $(REPO_LIB:%=%.a) $(REPO_LIB:%=%.cma) $(REPO_LIB:%=%.cmxa)\
	       $(REPO_MLI:%.mli=%.cmi)
SOLVER_FILES = $(SOLVER_LIB:%=%.a) $(SOLVER_LIB:%=%.cma) $(SOLVER_LIB:%=%.cmxa)\
	       $(SOLVER_MLI:%.mli=%.cmi)
CLIENT_FILES = $(CLIENT_LIB:%=%.a) $(CLIENT_LIB:%=%.cma) $(CLIENT_LIB:%=%.cmxa)\
	       $(CLIENT_MLI:%.mli=%.cmi)

FILES = $(CORE_FILES:%=_obuild/opam-core/%)\
	$(REPO_FILES:%=_obuild/opam-repositories/%)\
	$(SOLVER_FILES:%=_obuild/opam-solver/%)\
	$(CLIENT_FILES:%=_obuild/opam-client/%)

OCAMLBUILD_FILES =\
	$(CORE_FILES:%=_build/src/core/%)\
	$(REPO_FILES:%=_build/src/repositories/%)\
	$(SOLVER_FILES:%=_build/src/solver/%)\
	$(CLIENT_FILES:%=_build/src/client/%)

.PHONY: libuninstall libinstall libinstall-with-ocamlbuild
libinstall: META
	$(MAKE) libuninstall
	ocamlfind install opam META $(FILES)
libinstall-with-ocamlbuild: META
	$(MAKE) libuninstall
	ocamlfind install opam META $(OCAMLBUILD_FILES)
libuninstall:
	ocamlfind remove opam

doc: compile
	$(MAKE) -C doc

OPAM_FULL       = opam-full-$(version)
OPAM_FULL_TARGZ = $(OPAM_FULL).tar.gz

OPAM_FILES = $(wildcard src_ext/*.tar.gz)\
	     $(wildcard src_ext/*.tbz)\
	     $(shell git ls-tree --name-only -r HEAD)

prepare-archive:
	$(MAKE) -C src_ext distclean
	$(MAKE) clone
	rm -f $(OPAM_FULL) $(OPAM_FULL).tar.gz
	ln -s . $(OPAM_FULL)

# we want OPAM_FILES to be up-to-date here
complete-archive:
	tar cz $(addprefix $(OPAM_FULL)/,$(OPAM_FILES)) > $(OPAM_FULL).tar.gz
	rm -f $(OPAM_FULL)

$(OPAM_FULL_TARGZ):
	$(MAKE) prepare-archive
	$(MAKE) complete-archive

archive: $(OPAM_FULL_TARGZ)
	@
upload: $(OPAM_FULL_TARGZ)
	scp $(OPAM_FULL_TARGZ) webmaster@ocamlpro.com:pub/

configure: configure.ac m4/*.m4
	aclocal -I m4
	autoconf

release:
	git tag -d latest || true
	git tag -a latest -m "Latest release"
	git tag -a $(version) -m "Release $(version)"
	$(MAKE) upload

=== doc/Makefile ===
OPAM    = ../_obuild/opam/opam.byte
TOPICS  = $(shell $(OPAM) help topics)
OPAM_ADMIN = ../_obuild/opam-admin/opam-admin.byte
TOPICS_ADMIN = check make
HELPFMT = --help=groff

.PHONY: man html dev-manual tutorials
all: man tutorials dev html

man:
	rm -f man/*
	$(OPAM) $(HELPFMT) > man/opam.1
	for i in $(TOPICS); do\
	  $(OPAM) $$i $(HELPFMT) > man/opam-$$i.1;\
	done
	$(OPAM_ADMIN) $(HELPFMT) > man/opam-admin.1
	for i in $(TOPICS_ADMIN); do\
	  $(OPAM_ADMIN) $$i $(HELPFMT) > man/opam-admin-$$i.1;\
	done
	for i in opam-check; do\
	  pandoc -s -t man man-ext/$$i.md -o man/$$i.1;\
	done

tutorials:
	$(MAKE) -C tutorials

dev:
	$(MAKE) -C dev-manual

html:
	mkdir -p html/
	ocamldoc \
	  -I ../_obuild/opam-core -I ../_obuild/opam-solver \
	  -I ../_obuild/opam-repositories -I ../_obuild/opam-client \
	  -I ../_obuild/opam-lib -I ../_obuild/cudf -I ../_obuild/dose \
	  -I ../_obuild/re -I ../_obuild/unix -I ../_obuild/extlib \
	  -I ../_obuild/arg -I ../_obuild/graph -I ../_obuild/cmdliner \
	  ../src/**/*.mli -html -d html/

=== tests/Makefile ===
TMP_DIR   = $(realpath .)/tmp
OPAM_ROOT = $(TMP_DIR)/OPAM.ROOT
OPAM_REPO = $(TMP_DIR)/OPAM.REPO

# repositoy name
REPO      = test
REPOKIND ?= local

# To test GIT repo
OPAM_GIT = $(TMP_DIR)/OPAM.GIT

PACKAGES  = P1-1 P1-2 P2 P3 P4 P5

_OPAM = $(realpath ../_obuild/opam/opam.asm)
ENV   = PATH=$(PATH) $(DEBUG) OPAMKEEPBUILDDIR=1 OPAMROOT=$(OPAM_ROOT) OPAMYES=1 OPAM=$(_OPAM)
OPAM  = $(ENV) $(_OPAM)
CHECK = $(ENV) $(realpath ../_obuild/opam-check/opam-check.asm)

ifeq ($(OPAMTESTQUIET), 1)
  DEBUG =
else
  DEBUG = OPAMDEBUG=2 OCAMLRUNPARAM=b
endif

ARCHIVES  = $(PACKAGES:%=packages/%.tar.gz)

.PHONY: all local git

all: local git
	@

quiet:
	$(MAKE) OPAMTESTQUIET=1 all

run:
	$(MAKE) init && \
	$(MAKE) list && \
	$(MAKE) upload && \
	$(MAKE) install-remove && \
	$(MAKE) list && \
	$(MAKE) install-opt && \
	$(MAKE) list && \
	$(MAKE) install && \
	$(MAKE) list && \
	$(MAKE) reinstall && \
	$(MAKE) list && \
	$(MAKE) upload-new && \
	$(MAKE) list && \
	$(MAKE) upgrade && \
	$(MAKE) list && \
	$(MAKE) downgrade && \
	$(MAKE) list && \
	$(MAKE) switch-alias && \
	$(MAKE) list && \
	$(MAKE) switch-env-packages && \
	$(MAKE) repo && \
	$(MAKE) list
	@echo "SUCCESS!"

local:
	$(MAKE) clean
	$(MAKE) REPOKIND=local run

git:
	$(MAKE) clean
	$(MAKE) REPOKIND=git run

init:
	rm -rf $(OPAM_REPO)
	mkdir -p $(OPAM_REPO)
ifeq ($(REPOKIND), git)
	cd $(OPAM_REPO) && git init && \
	  touch README && git add README && \
	  git commit -a -m "Initial commit"
endif
	$(OPAM) init --no-setup --no-base-packages $(REPO) $(OPAM_REPO) -k $(REPOKIND)

upload: $(ARCHIVES)
	mkdir -p $(OPAM_REPO)/packages/P1.1
	cp packages/P1-1.opam     $(OPAM_REPO)/packages/P1.1/opam
	cp packages/P1-1/README   $(OPAM_REPO)/packages/P1.1/descr
	mkdir -p $(OPAM_REPO)/packages/P2.1
	cp packages/P2/README     $(OPAM_REPO)/packages/P2.1/descr
	cp packages/P2.opam       $(OPAM_REPO)/packages/P2.1/opam
	mkdir -p $(OPAM_REPO)/packages/P3.1~weird-version.test
	cp packages/P3.opam       $(OPAM_REPO)/packages/P3.1~weird-version.test/opam
	cp packages/P3/README     $(OPAM_REPO)/packages/P3.1~weird-version.test/descr
	mkdir -p $(OPAM_REPO)/packages/P4.1
	cp packages/P4-1.opam     $(OPAM_REPO)/packages/P4.1/opam
	cp packages/P4/README     $(OPAM_REPO)/packages/P4.1/descr
	mkdir -p $(OPAM_REPO)/packages/P5.1
	cp packages/P5.opam       $(OPAM_REPO)/packages/P5.1/opam
	cp packages/P5/README     $(OPAM_REPO)/packages/P5.1/descr
	mkdir -p $(OPAM_REPO)/compilers
	cp compilers/*            $(OPAM_REPO)/compilers/
ifeq ($(REPOKIND), git)
	echo 'git: "$(OPAM_GIT)/P1-1"' > $(OPAM_REPO)/packages/P1.1/url
	cd $(OPAM_REPO)/packages/P1.1/ && git add * && git commit -a -m "Adding P1"
	echo 'git: "$(OPAM_GIT)/P2"'   > $(OPAM_REPO)/packages/P2.1/url
	cd $(OPAM_REPO)/packages/P2.1/ && git add * && git commit -a -m "Adding P2"
	echo 'git: "$(OPAM_GIT)/P3"'   > $(OPAM_REPO)/packages/P3.1~weird-version.test/url
	cd $(OPAM_REPO)/packages/P3.1~weird-version.test/ && git add * && git commit -a -m "Adding P3"
	echo 'git: "$(OPAM_GIT)/P4"'   > $(OPAM_REPO)/packages/P4.1/url
	cd $(OPAM_REPO)/packages/P4.1/ && git add * && git commit -a -m "Adding P4"
	echo 'git: "$(OPAM_GIT)/P5"'   > $(OPAM_REPO)/packages/P5.1/url
	cd $(OPAM_REPO)/packages/P5.1/ && git add * && git commit -a -m "Adding P5"
	cd $(OPAM_REPO)/compilers && git add * && git commit -a -m "Adding compilers"
	rm -rf $(OPAM_GIT) && mkdir -p $(OPAM_GIT)
	mkdir $(OPAM_GIT)/P1-1 && cp packages/P1-1/* $(OPAM_GIT)/P1-1/
	mkdir $(OPAM_GIT)/P2   && cp packages/P2/*   $(OPAM_GIT)/P2/
	mkdir $(OPAM_GIT)/P3   && cp packages/P3/*   $(OPAM_GIT)/P3/
	mkdir $(OPAM_GIT)/P4   && cp packages/P4/*   $(OPAM_GIT)/P4/
	mkdir $(OPAM_GIT)/P5   && cp packages/P5/*   $(OPAM_GIT)/P5/
	cd $(OPAM_GIT)/P1-1 && git init && git add * && git commit -a -m "initial commit"
	cd $(OPAM_GIT)/P2   && git init && git add * && git commit -a -m "initial commit"
	cd $(OPAM_GIT)/P3   && git init && git add * && git commit -a -m "initial commit"
	cd $(OPAM_GIT)/P4   && git init && git add * && git commit -a -m "initial commit"
	cd $(OPAM_GIT)/P5   && git init && git add * && git commit -a -m "initial commit"
else
	mkdir -p $(OPAM_REPO)/archives
	cp packages/P1-1.tar.gz $(OPAM_REPO)/archives/P1.1+opam.tar.gz
	cp packages/P2.tar.gz $(OPAM_REPO)/archives/P2.1+opam.tar.gz
	cp packages/P3.tar.gz $(OPAM_REPO)/archives/P3.1~weird-version.test+opam.tar.gz
	cp packages/P4.tar.gz $(OPAM_REPO)/archives/P4.1+opam.tar.gz
	cp packages/P5.tar.gz $(OPAM_REPO)/archives/P5.1+opam.tar.gz
endif
	$(OPAM) update

list:
	$(OPAM) list -a

install-remove:
	$(CHECK) -l install-remove-1
	$(OPAM) install P1
	$(CHECK) -l install-remove-2 P1.1
	$(OPAM) remove P1
	$(CHECK) -l install-remove-3

install-opt:
	$(CHECK) -l install-opt-1
	$(OPAM) install P5
	test -f $(OPAM_ROOT)/system/lib/p5/p2_absent
	$(CHECK) -l install-opt-2 P1.1 P5.1
	$(OPAM) remove P5
	$(CHECK) -l install-opt-3 P1.1
	$(OPAM) install P5
	$(CHECK) -l install-opt-4 P1.1 P5.1
	$(OPAM) remove P5 -a
	$(CHECK) -l install-opt-5
	$(OPAM) install P5
	$(CHECK) -l install-opt-6 P1.1 P5.1
	$(OPAM) install P2
	test -f $(OPAM_ROOT)/system/lib/p5/p2_present
	$(CHECK) -l install-opt-7 P1.1 P2.1 P5.1
	$(OPAM) remove P5 -a
	$(CHECK) -l install-opt-8 P1.1 P2.1
	$(OPAM) remove P2 -a
	$(CHECK) -l install-opt-9
	$(OPAM) install P1 P2 P5
	test -f $(OPAM_ROOT)/system/lib/p5/p2_present
	$(CHECK) -l install-opt-10 P1.1 P2.1 P5.1
	$(OPAM) remove P2 -a
	test -f $(OPAM_ROOT)/system/lib/p5/p2_absent
	$(CHECK) -l install-opt-11 P1.1 P5.1
	$(OPAM) remove P1
	$(CHECK) -l install-opt-12

install:
	$(CHECK) -l install-1
	$(OPAM) install P1
	$(CHECK) -l install-2 P1.1
	$(OPAM) install P2
	$(CHECK) -l install-3 P1.1 P2.1
	$(OPAM) install P3
	$(CHECK) -l install-4 P1.1 P2.1 P3.1~weird-version.test
	$(OPAM) install P4
	$(CHECK) -l install-5 P1.1 P2.1 P3.1~weird-version.test P4.1

reinstall:
	$(CHECK) -l reinstall-1 P1.1 P2.1 P3.1~weird-version.test P4.1
	$(OPAM) reinstall P1
	$(CHECK) -l reinstall-2 P1.1 P2.1 P3.1~weird-version.test P4.1

upload-new:
	mkdir $(OPAM_REPO)/packages/P4.2
	cp packages/P4-2.opam   $(OPAM_REPO)/packages/P4.2/opam
	cp packages/P4/README   $(OPAM_REPO)/packages/P4.2/descr
	mkdir $(OPAM_REPO)/packages/P4.3
	cp packages/P4-3.opam   $(OPAM_REPO)/packages/P4.3/opam
	cp packages/P4/README   $(OPAM_REPO)/packages/P4.3/descr
ifeq ($(REPOKIND), git)
	echo "(* new line *)" >> $(OPAM_GIT)/P1-1/p1.ml
	cd $(OPAM_GIT)/P1-1 && git commit -a -m "a small change"
	echo 'git: "$(OPAM_GIT)/P4"' > $(OPAM_REPO)/packages/P4.2/url
	echo 'git: "$(OPAM_GIT)/P4"' > $(OPAM_REPO)/packages/P4.3/url
	cd $(OPAM_REPO) && git add * && git commit -a -m "Adding P4.2 and P4.3"
else
	mkdir $(OPAM_REPO)/packages/P1.2
	cp packages/P1-2.opam   $(OPAM_REPO)/packages/P1.2/opam
	cp packages/P1-2/README $(OPAM_REPO)/packages/P1.2/descr
	cp packages/P1-2.tar.gz $(OPAM_REPO)/archives/P1.2+opam.tar.gz
	cp packages/P4.tar.gz $(OPAM_REPO)/archives/P4.2+opam.tar.gz
	cp packages/P4.tar.gz $(OPAM_REPO)/archives/P4.3+opam.tar.gz
endif
	$(OPAM) update

upgrade:
	$(CHECK) -l upgrade-1 P1.1 P2.1 P3.1~weird-version.test P4.1
	$(OPAM) upgrade
ifeq ($(REPOKIND), git)
	$(CHECK) -l upgrade-2 P1.1 P2.1 P3.1~weird-version.test P4.3
else
	$(CHECK) -l upgrade-2 P1.2 P2.1 P3.1~weird-version.test P4.3
endif

downgrade:
ifeq ($(REPOKIND), git)
	$(CHECK) -l downgrade-1 P1.1 P2.1 P3.1~weird-version.test P4.3
else
	$(CHECK) -l downgrade-1 P1.2 P2.1 P3.1~weird-version.test P4.3
endif
	$(OPAM) install P4.2
	$(CHECK) -l downgrade-2 P1.1 P2.1 P3.1~weird-version.test P4.2

switch-alias:
	$(CHECK) -l switch-alias-1 P1.1 P2.1 P3.1~weird-version.test P4.2
	$(OPAM) remove P3.1~weird-version.test P4.2
	$(CHECK) -l switch-alias-2 P1.1 P2.1
	$(OPAM) switch export -f $(TMP_DIR)/export
	$(OPAM) switch install test --alias-of system --no-base-packages
	$(CHECK) -l switch-alias-3
	$(OPAM)	switch import -f $(TMP_DIR)/export
	$(CHECK) -l switch-alias-4 P1.1 P2.1
	$(OPAM) switch install test2 --alias-of 20
	$(CHECK) -l switch-alias-5
	$(OPAM) install P1
	$(CHECK) -l switch-alias-6 P1.1
	$(OPAM) switch system
	$(CHECK) -l switch-alias-7 P1.1 P2.1
	$(OPAM) switch remove test test2

switch-env-packages:
	$(CHECK) -l switch-env-packages-1 P1.1 P2.1
	$(OPAM) switch 10+a+b
ifeq ($(REPOKIND), git)
	$(CHECK) -l switch-env-packages-2 P1.1 P2.1 P3.1~weird-version.test P4.3
else
	$(CHECK) -l switch-env-packages-2 P1.2 P2.1 P3.1~weird-version.test P4.3
endif
	./test-TEST.sh $(wildcard $(OPAM_ROOT)/10+a+b/build/P4.3/P4*.env) "1"

repo:
	$(OPAM) repo add $(REPO)2 $(OPAM_REPO) -k $(REPOKIND)
	$(OPAM) repo remove $(REPO)2
	$(OPAM) repo remove $(REPO)

packages/%.tar.gz: packages/% 
	cd packages && tar czf $*.tar.gz $* 

clean:
	rm -f $(ARCHIVES)
	rm -rf $(TMP_DIR)

=== doc/dev-manual/Makefile ===
.PHONY: all
all: dev-manual.pdf
html: dev-manual.html

%.pdf: %.tex
	pdflatex $*
	pdflatex $*

%.html: %.tex
	hevea htmlmacros.hva $<

%.txt: %.html
	links -dump $< > $@

clean:
	rm -f *~ *.log *.toc *.out *.bbl *.blg *.aux

=== debian/changelog ===
opam (1.1.1-1) unstable; urgency=low

  * New upstream release.

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 02 Feb 2014 11:13:43 +0100

=== debian/control ===
Source: opam
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Mehdi Dogguy <mehdi@debian.org>
Build-Depends:
 debhelper (>= 8),
 ocaml-nox,
 camlp4,
 ocaml-findlib (>= 1.2.4),
 dh-ocaml (>= 0.9),
 libcudf-ocaml-dev,
 libdose3-ocaml-dev (>= 3.1.2),
 libre-ocaml-dev,
 libcmdliner-ocaml-dev,
 libextlib-ocaml-dev,
 libocamlgraph-ocaml-dev (>= 1.8),
 curl
Build-Depends-Indep:
 texlive-latex-base,
 texlive-lang-french,
 texlive-latex-extra,
 texlive-latex-recommended,
 texlive-fonts-recommended,
 pandoc,
 latex-make
Standards-Version: 3.9.4
Homepage: http://opam.ocamlpro.com
Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/opam.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/opam.git

Package: opam
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends},
 opam-docs (= ${source:Version}),
 build-essential,
 wget | curl
Recommends:
 ocaml,
 git,
 rsync
Description: package manager for OCaml
 OPAM stands for OCaml PAckage Manager. It aims to suit to a vast number
 of users and use cases, and has unique features:
  * Powerful handling of dependencies: versions constraints, optional
    dependencies, conflicts, etc.
  * Multiple repositories backends: HTTP, rsync, git
  * Ease to create packages and repositories
  * Ability to switch between different compiler versions
 .
 Typically, OPAM will probably make your life easier if you recognize
 yourself in at least one of these profiles:
  * You use multiple versions of the OCaml compiler, or you hack the compiler
    yourself and needs to frequently switch between compiler versions.
  * You use or develop software that needs a specific and/or modified version
    of the OCaml compiler to be installed.
  * You use or develop software that depends on a specific version of an OCaml
    library, or you just want to install a specific version of a package, not
    just the latest one.
  * You want to create your own packages yourself, put them on your own
    repository, with minimal effort.

Package: opam-docs
Architecture: all
Section: doc
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Description: package manager for OCaml (documentation)
 OPAM stands for OCaml PAckage Manager. It aims to suit to a vast number
 of users and use cases, and has unique features:
  * Powerful handling of dependencies: versions constraints, optional
    dependencies, conflicts, etc.
  * Multiple repositories backends: HTTP, rsync, git
  * Ease to create packages and repositories
  * Ability to switch between different compiler versions
 .
 Typically, OPAM will probably make your life easier if you recognize
 yourself in at least one of these profiles:
  * You use multiple versions of the OCaml compiler, or you hack the compiler
    yourself and needs to frequently switch between compiler versions.
  * You use or develop software that needs a specific and/or modified version
    of the OCaml compiler to be installed.
  * You use or develop software that depends on a specific version of an OCaml
    library, or you just want to install a specific version of a package, not
    just the latest one.
  * You want to create your own packages yourself, put them on your own
    repository, with minimal effort.
 .
 This package contains manpages and general documentation about OPAM.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DESTDIR=$(CURDIR)/debian/opam
include /usr/share/ocaml/ocamlvars.mk
OCAMLFIND_DESTDIR=$(DESTDIR)/$(OCAML_STDLIB_DIR)
BINEXT = $(if $(OCAML_OPT_ARCH),native,byte)

%:
	dh $@ --with ocaml

.PHONY: override_dh_auto_configure
override_dh_auto_configure:
	./configure
	$(MAKE) autogen
	for file in `ls -1 debian/buildsys/`; do \
		ln -s debian/buildsys/$$file; \
	done 

.PHONY: override_dh_auto_build
override_dh_auto_build:
	ocamlbuild $(OCAML_BEST).otarget
ifneq (,$(findstring opam-docs, $(shell dh_listpackages)))
	$(MAKE) -C doc OPAM=../opamMain.$(BINEXT) OPAM_ADMIN=../opam_admin.$(BINEXT) man
	$(RM) -f doc/dev-manual/dev-manual.pdf
	$(MAKE) -C doc/dev-manual
endif

.PHONY: override_dh_auto_test
override_dh_auto_test:
	true

.PHONY: override_dh_auto_install
override_dh_auto_install:
	mkdir -p $(DESTDIR)/usr/bin
	cp _build/src/client/opamMain.$(BINEXT)			$(DESTDIR)/usr/bin/opam
	cp _build/src/scripts/opam_admin.$(BINEXT)		$(DESTDIR)/usr/bin/opam-admin

.PHONY: override_dh_install
override_dh_install:
	dh_install --fail-missing

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	for file in `ls -1 debian/buildsys/`; do \
		$(RM) -f $$file || true; \
	done
	$(MAKE) clean || true
	$(RM) -rf _build
	$(RM) -f src/core/opamVersion.ml Makefile.config config.log config.status *.$(BINEXT)

.PHONY: override_dh_compress
override_dh_compress:
	dh_compress -X.pdf

=== debian/watch ===
version=3
https://github.com/ocamlpro/opam/tags/ /.*/([\d\.]+)\.tar\.gz

## opam 1.1.2

=== Makefile ===
-include Makefile.config

all: opam-lib opam opam-admin opam-installer
	@

#backwards-compat
compile with-ocamlbuild: all
	@
install-with-ocamlbuild: install
	@
libinstall-with-ocamlbuild: libinstall
	@

byte:
	$(MAKE) all USE_BYTE=true

src/%:
	$(MAKE) -C src $*

%:
	$(MAKE) -C src $@

lib-ext:
	$(MAKE) -C src_ext lib-ext

download-ext:
	$(MAKE) -C src_ext archives

clean-ext:
	$(MAKE) -C src_ext distclean

# With ocamlfind, prefer to install to the standard directory rather
# than $(prefix) if there are no overrides
ifndef LIBINSTALL_PREFIX
ifndef DESTDIR
ifneq ($(OCAMLFIND),no)
    LIBINSTALL_PREFIX = $(dir $(shell $(OCAMLFIND) printconf destdir))
endif
endif
endif

LIBINSTALL_PREFIX ?= $(prefix)

# Workaround bug #1355 in opam-installer
OPAM_INSTALLER = OPAMROOT=/tmp/opam-install-$@ src/opam-installer

libinstall:
	$(if $(wildcard src_ext/lib/*),$(error Installing the opam libraries is incompatible with embedding the dependencies. Run 'make clean-ext' and try again))
	$(OPAM_INSTALLER) --prefix $(DESTDIR)$(LIBINSTALL_PREFIX) --name opam opam-lib.install

install:
	$(OPAM_INSTALLER) --prefix $(DESTDIR)$(prefix) opam.install

libuninstall:
	$(OPAM_INSTALLER) -u --prefix $(DESTDIR)$(LIBINSTALL_PREFIX) --name opam opam-lib.install

uninstall:
	$(OPAM_INSTALLER) -u --prefix $(DESTDIR)$(prefix) opam.install

.PHONY: tests tests-local tests-git
tests: opam opam-admin opam-check
	$(MAKE) -C tests all

# tests-local, tests-git
tests-%: opam opam-admin opam-check
	$(MAKE) -C tests $*

.PHONY: doc
doc: opam-lib
	$(MAKE) -C doc

.PHONY: man
man: opam-lib
	$(MAKE) -C doc $@

configure: configure.ac m4/*.m4
	aclocal -I m4
	autoconf

release-tag:
	git tag -d latest || true
	git tag -a latest -m "Latest release"
	git tag -a $(version) -m "Release $(version)"


$(OPAM_FULL).tar.gz:
	$(MAKE) -C src_ext distclean
	$(MAKE) -C src_ext downloads
	rm -f $(OPAM_FULL) $(OPAM_FULL).tar.gz
	ln -s .

fast: src/core/opamGitVersion.ml src/core/opamScript.ml
	@if [ -n "$(wildcard src/*/*.cmi)" ]; then $(MAKE) clean; fi
	@ocp-build -init -scan
	@ln -sf ../_obuild/opam/opam.asm src/opam
	@ln -sf ../_obuild/opam-admin/opam-admin.asm src/opam-admin
	@ln -sf ../_obuild/opam-installer/opam-installer.asm src/opam-installer
	@ln -sf ../_obuild/opam-check/opam-check.asm src/opam-check

fastclean:
	@ocp-build -clean
	@rm -f $(addprefix src/, opam opam-admin opam-installer opam-check)

=== doc/Makefile ===
ifndef OPAM
  OPAM = ../src/opam
endif
BINDIR = $(dir $(OPAM))
SRCDIR = $(wildcard ../src/*)

TOPICS  = $(shell $(OPAM) help topics)
ifndef OPAM_ADMIN
  OPAM_ADMIN = $(BINDIR)/opam-admin
endif
TOPICS_ADMIN = check make
HELPFMT = --help=groff

SRCEXTDIR = ../src_ext/lib
INCLUDE = $(patsubst %,-I %,$(SRCDIR) $(SRCEXTDIR))

.PHONY: man html dev-manual tutorials
all: man tutorials dev html

man:
	rm -f man/*
	$(OPAM) $(HELPFMT) > man/opam.1
	for i in $(TOPICS); do\
	  $(OPAM) $$i $(HELPFMT) > man/opam-$$i.1;\
	done
	$(OPAM_ADMIN) $(HELPFMT) > man/opam-admin.1
	for i in $(TOPICS_ADMIN); do\
	  $(OPAM_ADMIN) $$i $(HELPFMT) > man/opam-admin-$$i.1;\
	done

tutorials:
	$(MAKE) -C tutorials

dev:
	$(MAKE) -C dev-manual

html:
	mkdir -p html/
	ocamldoc $(INCLUDE) ../src/*/*.mli ../src/*/*.ml -html -d html/

=== src/Makefile ===
-include ../Makefile.config

ifndef version
  $(error Please run ./configure)
endif

all: opam-lib opam opam-check opam-admin opam-installer opamlfind
	@

# --

OCAMLFLAGS = -g -w +a-4-9-32-41-44-45
OCAMLLDFLAGS = -g -w +a-4-9-32-41-44-45
ifeq ($OCAML_4,true)
  OCAMLFLAGS += -bin-annot
  OCAMLLDFLAGS += -bin-annot
endif
ifeq ($OCAML_4_01,true)
  OCAMLFLAGS += -short-paths
endif

export OCAMLFLAGS OCAMLLDFLAGS

USE_BYTE ?=
LIBEXT = $(if $(USE_BYTE),.cma,.cmxa)
BINTARGET = $(if $(USE_BYTE),byte-code,native-code)

# --

ifndef HAS_LIBEXT
  HAS_LIBEXT := $(wildcard ../src_ext/lib)
endif

ifneq ($(HAS_LIBEXT),)
  EXT_INCDIRS = ../src_ext/lib
  LIBS = unix extlib re cmdliner graph cudf dose_common dose_debian dose_algo
else
  ifeq ($(HAS_PACKAGES),)
    $(error Dependencies missing. Either run 'make lib-ext' or install them and re-run './configure')
  endif
  EXT_INCDIRS = $(shell $(OCAMLFIND) query $(PACKAGES))
  LIBS = $(basename $(shell $(OCAMLFIND) query -predicates byte -a-format $(PACKAGES)))
endif


# --

SUBS = core solver repositories client
OPAMLIB = $(patsubst %,./opam-%,$(SUBS))
INCDIRS = $(EXT_INCDIRS) $(SUBS)

export INCDIRS

opam-lib.byte: $(OPAMLIB:=.cma)
	@

opam-lib.native: $(OPAMLIB:=.cmxa)
	@

opam-lib: opam-lib.byte $(if $(USE_BYTE),,opam-lib.native)
	@

addmli = $(foreach ml,$(2),$(wildcard $(addsuffix .mli,$(basename $(1)/$(ml)))) $(1)/$(ml))

subtarget = SUBTARGET=$(if $(patsubst %.cma,,$@),native-code-library,byte-code-library)

opam-%.cma opam-%.cmxa:
	$(MAKE) -f $(OCAMLMAKEFILE) subprojs SUBPROJS=$* $(subtarget)

ALWAYS:
	@

# -- opam-core -- #
opam-core.cma opam-core.cmxa: core/opamScript.ml core/opamGitVersion.ml ALWAYS

.INTERMEDIATE: core/opamGitVersion.ml
core/opamGitVersion.ml: ../shell/get-git-id.ml
	cd .. && ocaml shell/get-git-id.ml src/$@

core/opamScript.ml: ../shell core/opamVersion.ml
	ocaml ../shell/crunch.ml "complete"     < ../shell/opam_completion.sh > $@
	ocaml ../shell/crunch.ml "complete_zsh" < ../shell/opam_completion_zsh.sh >> $@
	ocaml ../shell/crunch.ml "switch_eval"  < ../shell/opam_switch_eval.sh >> $@

SRC_core = \
  opamJson.ml \
  opamLineLexer.mll \
  opamMisc.ml \
  opamScript.ml \
  opamGitVersion.ml \
  opamVersion.ml \
  opamGlobals.ml \
  opamProcess.ml \
  opamRepositoryName.ml \
  opamSwitch.ml \
  opamSystem.ml \
  opamParallel.ml \
  opamFilename.ml \
  opamPackage.ml \
  opamVariable.ml \
  opamFormula.ml \
  opamCompiler.ml \
  opamTypes.ml \
  opamPath.ml \
  opamParser.mly \
  opamLexer.mll \
  opamFormat.ml \
  opamFile.ml \
  opamFilter.ml \
  opamRepository.ml

define PROJ_core
  SOURCES = $(call addmli,core,$(SRC_core))
  RESULT = opam-core
endef
export PROJ_core

# -- opam-solver -- #
opam-solver.cma: opam-core.cma
opam-solver.cmxa: opam-core.cmxa

SRC_solver = \
  opamCudf.ml \
  opamHeuristic.ml \
  opamSolver.ml

define PROJ_solver
  SOURCES = $(call addmli,solver,$(SRC_solver))
  RESULT = opam-solver
endef
export PROJ_solver

# -- opam-repositories -- #
opam-repositories.cma: opam-core.cma ALWAYS
opam-repositories.cmxa: opam-core.cmxa ALWAYS

SRC_repositories = \
  opamHTTP.ml \
  opamLocal.ml \
  opamVCS.ml \
  opamGit.ml \
  opamDarcs.ml \
  opamHg.ml

define PROJ_repositories
  SOURCES = $(call addmli,repositories,$(SRC_repositories))
  RESULT = opam-repositories
endef
export PROJ_repositories

# -- opam-client -- #
opam-client.cma: opam-core.cma opam-solver.cma opam-repositories.cma ALWAYS
opam-client.cmxa: opam-core.cmxa opam-solver.cmxa opam-repositories.cmxa ALWAYS

SRC_client = \
  opamState.ml \
  opamAction.ml \
  opamSolution.ml \
  opamSwitchCommand.ml \
  opamConfigCommand.ml \
  opamRepositoryCommand.ml \
  opamPinCommand.ml \
  opamClient.ml \
  opamArg.ml

define PROJ_client
  SOURCES = $(call addmli,client,$(SRC_client))
  RESULT = opam-client
endef
export PROJ_client

# -- opam binary -- #
opam: $(addsuffix $(LIBEXT),$(OPAMLIB)) ALWAYS
	$(MAKE) -f $(OCAMLMAKEFILE) subprojs SUBPROJS=opam SUBTARGET=$(BINTARGET)

define PROJ_opam
  SOURCES = client/opamMain.ml
  RESULT = opam
  LIBS = $(LIBS) $(OPAMLIB)
endef
export PROJ_opam

# -- opam utils -- #

SCRIPTS = opam-check opam-admin opam-installer opamlfind

$(SCRIPTS): opam ALWAYS
	$(MAKE) -f $(OCAMLMAKEFILE) subprojs SUBPROJS=$@ SUBTARGET=$(BINTARGET)

define PROJ_opam-check
  SOURCES = scripts/opam_check.ml
  RESULT = opam-check
  LIBS = $(LIBS) $(OPAMLIB)
endef
export PROJ_opam-check

SRC_opam-admin = \
  opam_mk_repo.ml \
  opam_repo_check.ml \
  opam_stats.ml \
  opam_depexts_change.ml \
  opam_admin.ml

define PROJ_opam-admin
  SOURCES = $(call addmli,scripts,$(SRC_opam-admin))
  RESULT = opam-admin
  LIBS = $(LIBS) $(OPAMLIB)
endef
export PROJ_opam-admin

define PROJ_opam-installer
  SOURCES = scripts/opam_installer.ml
  RESULT = opam-installer
  LIBS = $(LIBS) $(OPAMLIB)
endef
export PROJ_opam-installer

define PROJ_opamlfind
  SOURCES = scripts/opamlfind.ml
  RESULT = opamlfind
  LIBS = $(LIBS) $(OPAMLIB)
endef
export PROJ_opamlfind

# --

ifndef SUBPROJS
  export SUBPROJS = $(SUBS) opam opam-check opam-admin opam-installer opamlfind
endif

OCAMLMAKEFILE = ../OCamlMakefile
export OCAMLMAKEFILE

clean-aux:
	rm -f $(OPAMLIB:=.cma) $(OPAMLIB:=.cmxa) $(OPAMLIB:=.a) $(SCRIPTS)

clean: clean-aux

%:
	$(MAKE) -f $(OCAMLMAKEFILE) subprojs SUBTARGET=$@

=== src_ext/Makefile ===
-include ../Makefile.config

SRC_EXTS = extlib re cmdliner graph cudf dose

URL_extlib = http://ocaml-extlib.googlecode.com/files/extlib-1.5.3.tar.gz
MD5_extlib = 3de5f4e0a95fda7b2f3819c4a655b17c

URL_re = https://github.com/ocaml/ocaml-re/archive/ocaml-re-1.2.0.tar.gz
MD5_re = 5cbfc137683ef2b0e91f931577f2e673

URL_cmdliner = http://erratique.ch/software/cmdliner/releases/cmdliner-0.9.3.tbz
MD5_cmdliner = d63dd3b03966d65fc242246859c831c7

URL_graph = http://ocamlgraph.lri.fr/download/ocamlgraph-1.8.1.tar.gz
MD5_graph = 5aa256e9587a6d264d189418230af698

URL_cudf = https://gforge.inria.fr/frs/download.php/31910/cudf-0.6.3.tar.gz
MD5_cudf = 40c4e2c50ea96d0c9e565db16d20639a

URL_dose = https://gforge.inria.fr/frs/download.php/31595/dose3-3.1.2.tar.gz
MD5_dose = e98ff720fcc3873def46c85c6a980a1b

ARCHIVES = $(foreach lib,$(SRC_EXTS),$(notdir $(URL_$(lib))))
lib_of = $(foreach lib,$(SRC_EXTS),$(if $(findstring $(1),$(URL_$(lib))),$(lib),,))

# Portable md5check
MD5CHECK = ocaml ../shell/md5check.ml

lib-ext: clone build copy
	@

build: clone
	$(MAKE) -f $(OCAMLMAKEFILE) subprojs SUBTARGET=ncl

all: ncl

clone: $(SRC_EXTS:=.stamp) graph-workaround
	@

archives: $(SRC_EXTS:=.download)
	@

%.download:
	[ -e  $(notdir $(URL_$*)) ] || $(FETCH) $(URL_$*)
	$(MD5CHECK) $(notdir $(URL_$*)) $(MD5_$*)

%.stamp: %.download
	mkdir -p tmp
	cd tmp && tar xf$(if $(patsubst %.tar.gz,,$(URL_$*)),j,z) ../$(notdir $(URL_$*))
	rm -rf $*
	mv tmp/* $*
	rmdir tmp
	@if [ -d patches/$* ]; then \
          cd $* && \
	  for p in ../patches/$*/*.patch; do \
	    echo "== APPLYING PATCH $$p =="; \
	    patch -p1 < $$p; \
	  done; \
        fi
	@touch $@

# OCamlMakefile doesn'nt include stand-alone mlis in the packs...
graph-workaround:
	cp graph/src/sig.mli graph/src/sig.ml
	cp graph/src/sig_pack.mli graph/src/sig_pack.ml
	cp graph/src/dot_ast.mli graph/src/dot_ast.ml

clean:
	rm -rf lib
	$(MAKE) -f $(OCAMLMAKEFILE) subprojs SUBTARGET=cleanup

distclean:
	rm -rf cudf extlib re graph dose cmdliner
	rm -f depends.ocp
	rm -f *.tar.gz *.tbz *.stamp
	rm -f *.cm* *.o *.a
	rm -rf lib

LIB_EXTS = extlib re cmdliner graph cudf dose_common dose_debian dose_algo

inst_objs = cp $(1)/*.cm* $(1)/*.o lib

copy: build
	mkdir -p lib
	cp *.cma lib || true
	cp *.cmxa lib || true
	cp *.a lib || true
	$(call inst_objs,extlib)
	$(call inst_objs,re/lib)
	$(call inst_objs,cmdliner/src)
	$(call inst_objs,graph/src)
	$(call inst_objs,cudf)
	$(call inst_objs,dose/common)
	$(call inst_objs,dose/deb)
	$(call inst_objs,dose/algo)
	$(call inst_objs,.)

# --

addmli = $(foreach ml,$(2),$(wildcard $(addsuffix .mli,$(basename $(1)/$(ml)))) $(1)/$(ml))

SRC_extlib = enum.ml extHashtbl.ml extList.ml extString.ml global.ml install.ml	\
IO.ml option.ml pMap.ml refList.ml std.ml uChar.ml unzip.ml uTF8.ml optParse.ml	\
dynArray.ml dllist.ml bitSet.ml base64.ml extArray.ml extLib.ml

define PROJ_extlib
  SOURCES = $(call addmli,extlib,$(SRC_extlib))
  RESULT = extlib
  # Don't omit !! it leaks between subprojs...
  LIB_PACK_NAME =
endef
export PROJ_extlib

SRC_re = cset.ml automata.ml re.ml re_perl.ml re_pcre.ml re_emacs.ml re_glob.ml	\
re_str.ml

define PROJ_re
  SOURCES = $(call addmli,re/lib,$(SRC_re))
  RESULT = re
  LIB_PACK_NAME =
endef
export PROJ_re

SRC_cmdliner = cmdliner.ml

define PROJ_cmdliner
  SOURCES = $(call addmli,cmdliner/src,$(SRC_cmdliner))
  RESULT = cmdliner
  LIB_PACK_NAME =
endef
export PROJ_cmdliner

SRC_graph_lib = bitv.ml heap.ml unionfind.ml
SRC_graph = sig_pack.ml sig.ml dot_ast.ml builder.ml classic.ml delaunay.ml	\
dot_parser.mly fixpoint.ml gmap.ml gml.mll graphviz.ml oper.ml rand.ml strat.ml	\
traverse.ml util.ml version.ml kruskal.ml flow.ml dot_lexer.mll components.ml	\
coloring.ml blocks.ml dot.ml imperative.ml minsep.ml persistent.ml path.ml	\
topological.ml pack.ml mcs_m.ml cliquetree.ml md.ml

define PROJ_graph
  SOURCES = $(call addmli,graph/lib,$(SRC_graph_lib)) $(call addmli,graph/src,$(SRC_graph))
  RESULT = graph
  LIB_PACK_NAME = graph
endef
export PROJ_graph

SRC_cudf = cudf_types.ml cudf_type_parser.mly cudf_type_lexer.mll cudf_conf.ml	\
cudf_822_parser.mly cudf_822_lexer.mll cudf_types_pp.ml main_cudf_parse_822.ml	\
cudf.ml cudf_checker.ml cudf_parser.mly cudf_printer.ml main_cudf_check.ml	\
cudf_c.ml

define PROJ_cudf
  SOURCES = $(call addmli,cudf,$(SRC_cudf))
  RESULT = cudf
  LIB_PACK_NAME =
  INCDIRS = extlib
endef
export PROJ_cudf

SRC_dose_common = util.ml url.ml input.ml edosSolver.ml cudfSolver.ml	\
cudfAdd.ml cudfDiff.ml

define PROJ_dose_common
  SOURCES = $(call addmli,dose/common,$(SRC_dose_common))
  RESULT = dose_common
  LIB_PACK_NAME = common
  INCDIRS = extlib cudf re/lib
endef
export PROJ_dose_common

SRC_dose_debian = architecture.ml format822.ml format822_parser.mly		\
packages_parser.mly version.ml packages_lexer.mll format822_lexer.mll		\
packages.ml release.ml sources.ml evolution.ml debutil.ml debcudf.ml apt.ml	\
edsp.ml

define PROJ_dose_debian
  SOURCES = $(call addmli,dose/deb,$(SRC_dose_debian))
  RESULT = dose_debian
  LIB_PACK_NAME = debian
  INCDIRS = extlib cudf re/lib
endef
export PROJ_dose_debian

SRC_dose_algo = defaultgraphs.ml diagnostic_int.ml diagnostic.ml dominator.ml	\
dominators.ml flatten.ml statistics.ml depsolver_int.ml depsolver.ml		\
strongconflicts_int.ml strongconflicts.ml strongdeps_int.ml strongdeps.ml

define PROJ_dose_algo
  SOURCES = $(call addmli,dose/algo,$(SRC_dose_algo))
  RESULT = dose_algo
  LIB_PACK_NAME = algo
  INCDIRS = extlib graph/src dose/common dose/deb cudf
endef
export PROJ_dose_algo


# --

ifndef SUBROJS
  export SUBPROJS = $(LIB_EXTS)
endif


%:
	$(MAKE) -f $(OCAMLMAKEFILE) subprojs SUBTARGET=$@

OCAMLMAKEFILE = ../OCamlMakefile
export OCAMLMAKEFILE

=== tests/Makefile ===
--- 
+++ 
@@ -11,10 +11,14 @@
 
 PACKAGES  = P1-1 P1-2 P2 P3 P4 P5
 
-_OPAM = $(realpath ../_obuild/opam/opam.asm)
-ENV   = PATH=$(PATH) $(DEBUG) OPAMKEEPBUILDDIR=1 OPAMROOT=$(OPAM_ROOT) OPAMYES=1 OPAM=$(_OPAM)
-OPAM  = $(ENV) $(_OPAM)
-CHECK = $(ENV) $(realpath ../_obuild/opam-check/opam-check.asm)
+ifndef OPAM
+  OPAM = $(realpath ../src/opam)
+endif
+ENV   = PATH=$(PATH) $(DEBUG) OPAMKEEPBUILDDIR=1 OPAMROOT=$(OPAM_ROOT) OPAMYES=1 OPAM=$(OPAM)
+OPAMBIN  = $(ENV) $(OPAM)
+ifndef CHECK
+  CHECK = $(ENV) $(dir $(OPAM))/opam-check
+endif
 
 ifeq ($(OPAMTESTQUIET), 1)
   DEBUG =
@@ -73,7 +77,7 @@
 	  touch README && git add README && \
 	  git commit -a -m "Initial commit"
 endif
-	$(OPAM) init --no-setup --no-base-packages $(REPO) $(OPAM_REPO) -k $(REPOKIND)
+	$(OPAMBIN) init --no-setup --no-base-packages $(REPO) $(OPAM_REPO) -k $(REPOKIND)
 
 upload: $(ARCHIVES)
 	mkdir -p $(OPAM_REPO)/packages/P1.1
@@ -124,61 +128,61 @@
 	cp packages/P4.tar.gz $(OPAM_REPO)/archives/P4.1+opam.tar.gz
 	cp packages/P5.tar.gz $(OPAM_REPO)/archives/P5.1+opam.tar.gz
 endif
-	$(OPAM) update
+	$(OPAMBIN) update
 
 list:
-	$(OPAM) list -a
+	$(OPAMBIN) list -a
 
 install-remove:
 	$(CHECK) -l install-remove-1
-	$(OPAM) install P1
+	$(OPAMBIN) install P1
 	$(CHECK) -l install-remove-2 P1.1
-	$(OPAM) remove P1
+	$(OPAMBIN) remove P1
 	$(CHECK) -l install-remove-3
 
 install-opt:
 	$(CHECK) -l install-opt-1
-	$(OPAM) install P5
+	$(OPAMBIN) install P5
 	test -f $(OPAM_ROOT)/system/lib/p5/p2_absent
 	$(CHECK) -l install-opt-2 P1.1 P5.1
-	$(OPAM) remove P5
+	$(OPAMBIN) remove P5
 	$(CHECK) -l install-opt-3 P1.1
-	$(OPAM) install P5
+	$(OPAMBIN) install P5
 	$(CHECK) -l install-opt-4 P1.1 P5.1
-	$(OPAM) remove P5 -a
+	$(OPAMBIN) remove P5 -a
 	$(CHECK) -l install-opt-5
-	$(OPAM) install P5
+	$(OPAMBIN) install P5
 	$(CHECK) -l install-opt-6 P1.1 P5.1
-	$(OPAM) install P2
+	$(OPAMBIN) install P2
 	test -f $(OPAM_ROOT)/system/lib/p5/p2_present
 	$(CHECK) -l install-opt-7 P1.1 P2.1 P5.1
-	$(OPAM) remove P5 -a
+	$(OPAMBIN) remove P5 -a
 	$(CHECK) -l install-opt-8 P1.1 P2.1
-	$(OPAM) remove P2 -a
+	$(OPAMBIN) remove P2 -a
 	$(CHECK) -l install-opt-9
-	$(OPAM) install P1 P2 P5
+	$(OPAMBIN) install P1 P2 P5
 	test -f $(OPAM_ROOT)/system/lib/p5/p2_present
 	$(CHECK) -l install-opt-10 P1.1 P2.1 P5.1
-	$(OPAM) remove P2 -a
+	$(OPAMBIN) remove P2 -a
 	test -f $(OPAM_ROOT)/system/lib/p5/p2_absent
 	$(CHECK) -l install-opt-11 P1.1 P5.1
-	$(OPAM) remove P1
+	$(OPAMBIN) remove P1
 	$(CHECK) -l install-opt-12
 
 install:
 	$(CHECK) -l install-1
-	$(OPAM) install P1
+	$(OPAMBIN) install P1
 	$(CHECK) -l install-2 P1.1
-	$(OPAM) install P2
+	$(OPAMBIN) install P2
 	$(CHECK) -l install-3 P1.1 P2.1
-	$(OPAM) install P3
+	$(OPAMBIN) install P3
 	$(CHECK) -l install-4 P1.1 P2.1 P3.1~weird-version.test
-	$(OPAM) install P4
+	$(OPAMBIN) install P4
 	$(CHECK) -l install-5 P1.1 P2.1 P3.1~weird-version.test P4.1
 
 reinstall:
 	$(CHECK) -l reinstall-1 P1.1 P2.1 P3.1~weird-version.test P4.1
-	$(OPAM) reinstall P1
+	$(OPAMBIN) reinstall P1
 	$(CHECK) -l reinstall-2 P1.1 P2.1 P3.1~weird-version.test P4.1
 
 upload-new:
@@ -202,11 +206,11 @@
 	cp packages/P4.tar.gz $(OPAM_REPO)/archives/P4.2+opam.tar.gz
 	cp packages/P4.tar.gz $(OPAM_REPO)/archives/P4.3+opam.tar.gz
 endif
-	$(OPAM) update
+	$(OPAMBIN) update
 
 upgrade:
 	$(CHECK) -l upgrade-1 P1.1 P2.1 P3.1~weird-version.test P4.1
-	$(OPAM) upgrade
+	$(OPAMBIN) upgrade
 ifeq ($(REPOKIND), git)
 	$(CHECK) -l upgrade-2 P1.1 P2.1 P3.1~weird-version.test P4.3
 else
@@ -219,29 +223,29 @@
 else
 	$(CHECK) -l downgrade-1 P1.2 P2.1 P3.1~weird-version.test P4.3
 endif
-	$(OPAM) install P4.2
+	$(OPAMBIN) install P4.2
 	$(CHECK) -l downgrade-2 P1.1 P2.1 P3.1~weird-version.test P4.2
 
 switch-alias:
 	$(CHECK) -l switch-alias-1 P1.1 P2.1 P3.1~weird-version.test P4.2
-	$(OPAM) remove P3.1~weird-version.test P4.2
+	$(OPAMBIN) remove P3.1~weird-version.test P4.2
 	$(CHECK) -l switch-alias-2 P1.1 P2.1
-	$(OPAM) switch export -f $(TMP_DIR)/export
-	$(OPAM) switch install test --alias-of system --no-base-packages
+	$(OPAMBIN) switch export -f $(TMP_DIR)/export
+	$(OPAMBIN) switch install test --alias-of system --no-base-packages
 	$(CHECK) -l switch-alias-3
-	$(OPAM)	switch import -f $(TMP_DIR)/export
+	$(OPAMBIN)	switch import -f $(TMP_DIR)/export
 	$(CHECK) -l switch-alias-4 P1.1 P2.1
-	$(OPAM) switch install test2 --alias-of 20
+	$(OPAMBIN) switch install test2 --alias-of 20
 	$(CHECK) -l switch-alias-5
-	$(OPAM) install P1
+	$(OPAMBIN) install P1
 	$(CHECK) -l switch-alias-6 P1.1
-	$(OPAM) switch system
+	$(OPAMBIN) switch system
 	$(CHECK) -l switch-alias-7 P1.1 P2.1
-	$(OPAM) switch remove test test2
+	$(OPAMBIN) switch remove test test2
 
 switch-env-packages:
 	$(CHECK) -l switch-env-packages-1 P1.1 P2.1
-	$(OPAM) switch 10+a+b
+	$(OPAMBIN) switch 10+a+b
 ifeq ($(REPOKIND), git)
 	$(CHECK) -l switch-env-packages-2 P1.1 P2.1 P3.1~weird-version.test P4.3
 else
@@ -250,9 +254,9 @@
 	./test-TEST.sh $(wildcard $(OPAM_ROOT)/10+a+b/build/P4.3/P4*.env) "1"
 
 repo:
-	$(OPAM) repo add $(REPO)2 $(OPAM_REPO) -k $(REPOKIND)
-	$(OPAM) repo remove $(REPO)2
-	$(OPAM) repo remove $(REPO)
+	$(OPAMBIN) repo add $(REPO)2 $(OPAM_REPO) -k $(REPOKIND)
+	$(OPAMBIN) repo remove $(REPO)2
+	$(OPAMBIN) repo remove $(REPO)
 
 packages/%.tar.gz: packages/% 
 	cd packages && tar czf $*.tar.gz $*

=== debian/changelog ===
opam (1.1.2-1) UNRELEASED; urgency=low

  * Initial package

 -- Euan Harris <euan.harris@citrix.com>  Fri, 01 Aug 2014 12:00:00 +0000

=== debian/control ===
Source: opam
Priority: optional
Maintainer: Euan Harris <euan.harris@citrix.com>
Section: ocaml
Standards-Version: 3.9.3
Build-Depends:
 dh-ocaml (>= 0.9),
 ocaml-nox,
 python,
 debhelper (>= 8),
 ocaml-native-compilers,
 curl

Package: opam
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Recommends: ocaml-findlib
Description: Source-based OCaml package manager
 Source-based OCaml package manager
